// --------------------------------------------------------------------------
// Licensed Materials - Property of IBM
//
// 5725-A06 5725-A29 5724-Y48 5724-Y49 5724-Y54 5724-Y55
// Copyright IBM Corporation 1998, 2013. All Rights Reserved.
//
// Note to U.S. Government Users Restricted Rights:
// Use, duplication or disclosure restricted by GSA ADP Schedule
// Contract with IBM Corp.
// --------------------------------------------------------------------------
// October 13. This is the model file used for Desir-Goyal datasets for the conic, conic+mcc and milp+mcc 
// formulations

int   NbProducts = ...;
int   NbRetailers = ...;
range Products = 1..NbProducts;
range Retailers =1..NbRetailers;
int Capacity = ...;
float multiplier=0.5;
float Fraction[Retailers] = ...;
float Preference[Retailers][Products] = ...;
int   Rank[Retailers][Products] = ...;
float Revenue[Retailers][Products] = ...;
float Weight[Products]=...;
float RevenueMax[Retailers]=...;
float MaximumCap[Retailers][Products]=...;
dvar boolean    x[Products];
dvar float+    t[Retailers][Products];
dvar float+    t0[Retailers];
dvar float+    w10[Retailers];
minimize sum(i in Retailers,j in Products:Preference[i][j]>0) Fraction[i]*(RevenueMax[i]-Revenue[i][j])*multiplier*Preference[i][j]*t[i][j]+sum(i in Retailers) RevenueMax[i]*Fraction[i]*t0[i];
 subject to {
   sum(j in Products) Weight[j]*x[j]<=Capacity;  
   forall(i in Retailers)
     w10[i]==sum(j in Products:Preference[i][j]>0) (multiplier*Preference[i][j]*x[j])+1;
   forall(i in Retailers, j in Products:Preference[i][j]>0)
     t[i][j]*w10[i]>=x[j]^2;
   forall(i in Retailers)
     t0[i]*w10[i]>=1;    
   forall(i in Retailers)
     t0[i]+sum(j in Products)multiplier*Preference[i][j]*t[i][j]>=1;
//  forall(i in Retailers, j in Products:Preference[i][j]>0)
//    t[i][j]<=x[j]*(1/(1+multiplier*Preference[i][j]));
//  forall(i in Retailers, j in Products: Rank[i][j]>=Capacity+1)
//      if(Preference[i][j]>0)
//         t[i][j]>=x[j]*(1/(1+multiplier*Preference[i][j]+multiplier*MaximumCap[i][Capacity-1]));
//  forall(i in Retailers, j in Products: Rank[i][j]<=Capacity)
//      if(Preference[i][j]>0) 
//         t[i][j]>=x[j]*(1/(1+multiplier*MaximumCap[i][Capacity]));
//  forall(i in Retailers, j in Products: Rank[i][j]>=Capacity+1)
//      if(Preference[i][j]>0)
//        t[i][j]<=t0[i]-(1-x[j])*(1/(1+multiplier*MaximumCap[i][Capacity]));
//  forall(i in Retailers, j in Products:Rank[i][j]<=Capacity)
//      if(Capacity<NbProducts)
//        if(Preference[i][j]>0) 
//           t[i][j]<=t0[i]-(1-x[j])*(1/(1+multiplier*MaximumCap[i][Capacity+1]-multiplier*Preference[i][j]));  
//  forall(i in Retailers, j in Products:Rank[i][j]<=Capacity)
//      if(Capacity==NbProducts)
//        if(Preference[i][j]>0) 
//           t[i][j]<=t0[i]-(1-x[j])*(1/(1+multiplier*MaximumCap[i][Capacity]-multiplier*Preference[i][j]));
//  forall(i in Retailers, j in Products)
//      if(Preference[i][j]>0)
//        t[i][j]>=t0[i]-(1-x[j]);  
}      
